%define current_version 7.0.42
%define _incdir /usr/include/ploop
Summary: ploop tools
Name: ploop
Version: %{current_version}
Release:        1%{?dist}
Group: Applications/System
License: GPLv2
Source: %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: ploop-lib = %{version}-%{release}
BuildRequires: libxml2-devel libuuid-devel openssl-devel
BuildRequires: e2fsprogs-devel
ExclusiveArch: x86_64

%description
This package contains tools to work with ploop devices and images.

%prep
%setup -q

%build
make %{?_smp_mflags} LIBDIR=%{_libdir} PLOOP_LOG_FILE=/var/log/ploop.log all

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/%{_sbindir}
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
mkdir -p %{buildroot}%{_docdir}/%{name}-lib-%{version}
mkdir -p %{buildroot}%{_docdir}/%{name}-devel-%{version}
make DESTDIR=%{buildroot} LIBDIR=%{_libdir} PLOOP_LOG_FILE=/var/log/ploop.log install
install -m 644 COPYING GPL-2.0  %{buildroot}%{_docdir}/%{name}-%{version}/
install -m 644 COPYING GPL-2.0 LGPL-2.1 %{buildroot}%{_docdir}/%{name}-lib-%{version}/
install -m 644 COPYING GPL-2.0 LGPL-2.1 %{buildroot}%{_docdir}/%{name}-devel-%{version}/

%clean
rm -rf %{buildroot}

%files
%attr(755,root,root) /sbin/*
%attr(755,root,root) %{_sbindir}/ploop
%attr(755,root,root) %{_sbindir}/ploop-*
%attr(644,root,root) /etc/logrotate.d/ploop
%attr(644,root,root) %{_mandir}/man8/ploop.8.*
%{_docdir}/%{name}-%{version}

%package lib
Summary: ploop library
Group: Applications/System
License: LGPLv2.1
Requires: libxml2
Requires: parted
Conflicts: vzkernel < 2.6.32-042stab061.1
Requires: util-linux
Requires: e2fsprogs
Requires: lsof
Requires: findutils
Conflicts: vzctl < 4.5

%description lib
Parallels loopback (ploop) block device API library

%files lib
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libploop.so.*
%dir /var/lock/ploop
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%{_docdir}/%{name}-lib-%{version}

%post lib -p /sbin/ldconfig

%postun lib -p /sbin/ldconfig

%triggerin lib -- systemd
SCRIPT="/lib/udev/rules.d/60-persistent-storage.rules"
if [ -f $SCRIPT ]; then
	fgrep 'KERNEL=="ploop*", GOTO="persistent_storage_end"' $SCRIPT > /dev/null 2>&1 ||
	sed -i -e '1 s/^/KERNEL=="ploop*", GOTO="persistent_storage_end"\n/;' $SCRIPT
fi

%package devel
Summary: Headers for development with ploop library
Group: Applications/System
License: GPLv2 or LGPLv2.1
Requires: pkgconfig
%description devel
Headers and a static version of ploop library

%files devel
%defattr(-,root,root)
%dir %{_incdir}
%attr(644,root,root) %{_libdir}/libploop.a
%{_libdir}/pkgconfig/ploop.pc
%{_libdir}/libploop.so
%attr(644,root,root) %{_incdir}/libploop.h
%attr(644,root,root) %{_incdir}/ploop_if.h
%attr(644,root,root) %{_incdir}/ploop1_image.h
%attr(644,root,root) %{_incdir}/dynload.h
%{_docdir}/%{name}-devel-%{version}

%package -n python-%{name}
Summary: Python bindings for %{name}
Group: Development/Languages
Requires: %{name}-lib = %{version}-%{release}
Requires: python2 >= 2.7
BuildRequires: python2-devel >= 2.7

%description -n python-%{name}
python-%{name} contains Python bindings for %{name}.

%files -n python-%{name}
%dir %{python2_sitearch}/libploop
%{python2_sitearch}/libploop/*
%{python2_sitearch}/*.egg-info

%changelog
* Thu Jul 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.42
 - Call PLOOP_IOC_FREEZE on partition #PSBM-49837

* Thu Jul 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.41
 - ploop_get_dev_by_delta(): ignore realpath() error #PSBM-49902

* Fri Jul 15 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.40
 - USe new ioctl to freeze ploop device #PSBM-49179
 - ploop_if.h: add PLOOP_IOC_FREEZE and PLOOP_IOC_THAW ioctls
 - Disk encryptuin: add keyid parameter to DiskDescriptor.xml

* Thu Jun 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.39
 - ploop_copy_receiver: truncate image on dst #PSBM-49076

* Fri Jun 17 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.38
 - Create .statfs and DiskDescriptor.xml.lck with 644 mode (v2) #PSBM-48352

* Thu Jun 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.37
 - Create .statfs and DiskDescriptor.xml.lck with 644 mode #PSBM-48352

* Fri Jun 10 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.36
 - Update ploop_if.h header to the latest kernel version
 - Error in ploop_fname_cmp (ploop.c:1129): No such file or directory

* Thu Jun 02 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.35
 - Add ploop_read_dd() to public API

* Fri May 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.34
 - ploop-copy.c: u32 passed as u64 to send_image_block() #PSBM-47575

* Thu May 26 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.33
 - ploop-copy: CBT live migration #PSBM-47128
 - Fix close of 0 descriptor in case of error in grow_lower_delta. #PSBM-47329

* Tue May 24 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.32
 - send_image_block (ploop-copy.c:480): Error from read: Bad address #PSBM-46720

* Mon May 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.31
 - Port CBT support from PSBM6

* Fri May 13 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.30
 - Sync ploop_if.h with the latest kernel version (#PSBM-45001)
 - Add --defrag flag for usage and man (Kir Kolyshkin <kir@openvz.org>)
 - include/dynload.h: version for ploop_get_base_delta_fname() (Kir Kolyshkin
<kir@openvz.org>)
 - ploop_discard(): nitpick in a comment (Kir Kolyshkin <kir@openvz.org>)
 - get_delta_fname: make static (Kir Kolyshkin <kir@openvz.org>)

* Thu Apr 21 2016 Igor Sukhih <igor@parallels.com> 7.0.29
 - discard/defrag: take into account image size change caused by defrag #PSBM-42548 #PSBM-45364
 - Unable to create ploop image > 16TB without filesystem inside #PSBM-45162

* Sat Apr 16 2016 Igor Sukhih <igor@parallels.com> 7.0.28
 - ploop discard operation cancelled on fs defragmentation error #PSBM-46198

* Fri Apr 15 2016 Igor Sukhih <igor@parallels.com> 7.0.27
 - Lock descriptor before accessing it in ploop_get_*_delta_fname() #PSBM-45496

* Fri Apr 15 2016 Igor Sukhih <igor@parallels.com> 7.0.26
 - api to get base delta file name #PSBM-46238

* Thu Apr 14 2016 Igor Sukhih <igor@parallels.com> 7.0.25
 - ploop-copy: Ploop image coruption  #PSBM-45837

* Wed Apr 13 2016 Igor Sukhih <igor@parallels.com> 7.0.24
 - ploop_copy_init(): open folder with O_DIRECTORY flag
 - send_async(): use pthread_cond_signal() under lock
 - Rework check_snapshot_mount()
 - ploop_merge_snapshot_by_guid(): improve messages 

* Tue Mar 29 2016 Igor Sukhih <igor@parallels.com> 7.0.23
 - add ploop_create_snapshot_offline() #PSBM-42981

* Thu Mar 24 2016 Igor Sukhih <igor@parallels.com> 7.0.22
 - python: Add snapshot create/delete bindings
 - python: fix error message for PyArg_ParseTuple()
 - do_mntn_merge(): fix the check for same file
 - complete_running_operation(): unexport

* Wed Feb 24 2016 Igor Sukhih <igor@parallels.com> 7.0.21
 - Fix statistics returned during ploop copying, #PSBM-41177
 - ploop_mount_fs(): rectify wrt remount
 - ploop_mount_fs: don't mount ro when finding balloon inode

* Wed Feb 10 2016 Igor Sukhih <igor@parallels.com> 7.0.20
 - Repair DiskDescriptot.xml on process PLOOP_MNTN_MERGE stage #PSBM-33414
 - Makefile: .depend file is not removed on 'make clean'
 - mount_image(): kill flags argument
 - Fix compile with gcc-5.3.0
 - Fix compile with musl wrt gnu_dev_*
 - Fix compile with musl wrt offsetof
 - gensym.sh: busybox sed compatibility

* Thu Feb 04 2016 Igor Sukhih <igor@parallels.com> 7.0.19
 - ploop_umount(): possible NULL pointer derefference
 - Rmove temporary mount point on ploop umount #PSBM-42493
 - Remove temporary mount point on offline ploop resize #PSBM-42493
 - Remove temporary mount point on ploop umount #PSBM-42493

* Tue Jan 26 2016 Igor Sukhih <igor@parallels.com> 7.0.18
 - Remove temporary mount point on offline ploop resize #PSBM-42493

* Fri Jan 22 2016 Igor Sukhih <igor@parallels.com> 7.0.17
 - Remove temporary mount point on ploop umount #PSBM-42493

* Fri Jan 15 2016 Igor Sukhih <igor@parallels.com> 7.0.16
 - Directory root.hds.mnt is left after container resize #PSBM-42493

* Wed Nov 11 2015 Igor Sukhih <igor@parallels.com> 7.0.15
 - ploop balloon discard infinite loop #PSBM-40948

* Mon Oct 26 2015 Igor Sukhih <igor@parallels.com> 7.0.14
 - Resize ploop image mounted inside mnt namespace #PSBM-39492

* Tue Oct 20 2015 Igor Sukhih <igor@parallels.com> 7.0.13
 - mount_image: return SYSEXIT_NOSNAP error, #PSBM-38423

* Fri Oct 09 2015 Igor Sukhih <igor@parallels.com> 7.0.12
 - ploop defragmentation support #PSBM-30163

* Wed Oct 07 2015 Igor Sukhih <igor@parallels.com> 7.0.11
 - do_delete_snapshot: pass copy of guid parameter
 - ploop_get_devs: NULL pointer dereference, #PSBM-40203

* Wed May 06 2015 Igor Sukhih <igor@parallels.com> 7.0.10
 - Add makefile for python bindings, #PSBM-28485

* Fri Apr 10 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.9
 - Updated GPL text

* Thu Apr 09 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.8
 - Updated license #PSBM-26806

* Tue Apr 07 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.7
 - soname changed to libploop.so.7.0.x #PSBM-32811

* Tue Apr 07 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.6
 - Revert to version number to libploop.so.1.12

* Mon Apr 06 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.5
 - Move version to Makefile.version

